/*
 *TABLAS DEL MODULO ESTADISTICO
 */

SET TRANSACTION READ WRITE;

DROP TABLE me_Central_Consumo_contadores;
DROP TABLE me_Valor_medio_consumo;
DROP TABLE me_Linea_mas_cargada;
DROP TABLE me_Porcentaje_lineas_mas_50;
DROP TABLE me_Numero_centrales_menos_30;
DROP TABLE me_Top_contadores_mas_consumo;
DROP TABLE me_consumo_medio_Clientes;

CREATE TABLE me_Central_Consumo_contadores
(
	codigo_central_p VARCHAR2(10)NOT NULL,
	consumo_acumulado NUMBER(16,2),
	CONSTRAINT pk_me_central PRIMARY KEY (codigo_central_p)
);

CREATE TABLE me_Valor_medio_consumo 
(
	id_linea NUMBER(10)NOT NULL,
	anyo NUMBER(4)NOT NULL,
	valor_medio_consumo NUMBER(10,2),
	CONSTRAINT pk_me_valor_medio PRIMARY KEY (id_linea,anyo)
);

CREATE TABLE me_Linea_mas_cargada
(
	identificador NUMBER(1) NOT NULL,
	id_linea NUMBER(10) NOT NULL,
	max_total_consumo NUMBER(16,2),
	CONSTRAINT pk_me_linea_cargada PRIMARY KEY (identificador)
);

CREATE TABLE me_Porcentaje_lineas_mas_50 
(
	anyo NUMBER(4) NOT NULL,
	porcentaje_mas_50 NUMBER(5,2),
	CONSTRAINT pk_me_Porcentaje_mas_50 PRIMARY KEY(anyo)
);

CREATE TABLE me_Numero_centrales_menos_30
(
	anyo NUMBER(4) NOT NULL,
	num_centrales NUMBER(6),
	CONSTRAINT pk_me_Porcentaje_menos_30 PRIMARY KEY(anyo)
);

CREATE TABLE me_Top_contadores_mas_consumo
(
	id_contador NUMBER(10)NOT NULL,
        consumo NUMBER(16,2) DEFAULT(0.0)
);

CREATE TABLE me_consumo_medio_Clientes
(
	consumo_medio NUMBER(6,2)
);

COMMIT;