/*Procedimiento que a partir de los datos de los contadores  nos permitir listar el identificador del cliente, el 
 *nmero del contrato y el modelo de contador asociado a estos siempre que el contador se encuentre conectado
 *a ms de una central de distribucin y estas a su vez a ms de una lnea de alimentacin.
 *PARAMETROS IN: CURSOR_R (Variable de tipo SYS_REFCURSOR, que se corresponde con el parmetro de retorno que contendr
 *		 los datos solicitados)
 *		 RSP (Variable de tipo CLOB que se corresponde con el parmetro de retorno).
 *RETURN: 	 CURSOR_R (Contendr el identificador, la direccion, la localidad y el pais y el ao de
 *		 fabricacin del contador, mostrado en este orden) 
 *		 Parmetro RSP que contendr informacin sobre el resultado de la ejecucin del procedimiento.
 */


CREATE OR REPLACE
PROCEDURE pr_consulta_d(CURSOR_R OUT NOCOPY SYS_REFCURSOR, RSP OUT NOCOPY CLOB) AS

    --Declaracin de variables para la tabla Log
    fecha_proceso VARCHAR2(20);
    nombre_proceso VARCHAR2(35);
    In_log CLOB;

    --Declaracin de variables 
    dni VARCHAR2(15);
    contrato VARCHAR2(15);
    modelo_contador VARCHAR2(15);

  
    --Iniciamos
    BEGIN
                     
        fecha_proceso:= TO_CHAR(SYSTIMESTAMP,'DD-MM-YYYY HH24:MI:SS');
        nombre_proceso:='pr_consulta_d';
      
        --Creamos una cadena de texto con los parametros de entrada.

        In_log:= TO_CHAR('Sin parametros de entrada');  
        

       --Abrimos el cursor
       
        OPEN CURSOR_R FOR
		SELECT TCLI.ID_CLIENTE, TCON.ID_CONTRATO, TCO.MODELO FROM TB_CLIENTES TCLI 
		INNER JOIN
			(TB_CONTRATOS TCON INNER JOIN TB_CONTADORES TCO ON TCON.CONTADOR=TCO.ID_CONTADOR)
			 ON TCLI.ID_CLIENTE=TCON.CLIENTE 
		WHERE (SELECT COUNT(*) FROM TB_DISTRIBUCION TDI WHERE TDI.CONTADOR=TCO.ID_CONTADOR)>1
		AND (SELECT COUNT(*) FROM TB_ALIMENTACION TAL WHERE TAL.DIRECCION IN 
			(SELECT TDI.DIRECCION FROM TB_DISTRIBUCION TDI WHERE TDI.CONTADOR=TCO.ID_CONTADOR)
		AND TAL.LOCALIDAD IN (SELECT TDI.LOCALIDAD FROM TB_DISTRIBUCION TDI WHERE TDI.CONTADOR=TCO.ID_CONTADOR)
		AND TAL.PAIS IN (SELECT TDI.PAIS FROM TB_DISTRIBUCION TDI WHERE TDI.CONTADOR=TCO.ID_CONTADOR))/
			(SELECT COUNT(*) FROM TB_DISTRIBUCION TDI WHERE TDI.CONTADOR=TCO.ID_CONTADOR)>1;
        
        --Recorremos el cursor para comprobar resultados 
        LOOP FETCH CURSOR_R INTO dni,contrato, modelo_contador;
        EXIT WHEN CURSOR_R%NOTFOUND;  
		dbms_output.put_line(dni ||'   '||contrato||'   '||modelo_contador);
        END LOOP;
	        
        RSP:='OK';
        INSERT INTO tb_Logs VALUES (seq_id_logs.NextVal,fecha_proceso,nombre_proceso,In_log,'cursor con los datos solicitados',RSP); 
        COMMIT;
 
     EXCEPTION
       
        WHEN OTHERS THEN 
        RSP:='ERROR: ' || SQLCODE || ' ' || SQLERRM;  
        INSERT INTO tb_Logs VALUES (seq_id_logs.NextVal,fecha_proceso,nombre_proceso,In_log,NULL,RSP);
    END;

