/*Procedimiento que a partir de los datos de los contadores  nos permitir listar los datos de los contadores
 *con un determinado nmero de aos de antigedad.
 *PARAMETROS IN: antiguedad (Variable de tipo NUMBER, contiene el nmero de aos de antigedad que ha de tener como mnimo
 *	         un contador)
 *               CURSOR_R (Variable de tipo SYS_REFCURSOR, que se corresponde con el parmetro de retorno que contendr
 *			   los datos solicitados)
 *		 RSP (Variable de tipo CLOB que se corresponde con el parmetro de retorno).
 *RETURN: 	 CURSOR_R (Contendr el identificador, la direccion, la localidad y el pais y el ao de
 *		 fabricacin del contador, mostrado en este orden) 
 *		 Parmetro RSP que contendr informacin sobre el resultado de la ejecucin del procedimiento.
 */


CREATE OR REPLACE
PROCEDURE pr_consulta_g(antiguedad IN NUMBER, CURSOR_R OUT NOCOPY SYS_REFCURSOR, RSP OUT NOCOPY CLOB) AS

    --Declaracin de variables para la tabla Log
    fecha_proceso VARCHAR2(20);
    nombre_proceso VARCHAR2(35);
    In_log CLOB;

    --Declaracin de variables 
    id_cont NUMBER(10);
    dir VARCHAR2(50);
    loc VARCHAR2(50);
    ps VARCHAR2(25);
    af NUMBER(4);
    any_actual NUMBER(4);

  
    --Iniciamos
    BEGIN
                     
        fecha_proceso:= TO_CHAR(SYSTIMESTAMP,'DD-MM-YYYY HH24:MI:SS');
        nombre_proceso:='pr_consulta_g';
      
        --Creamos una cadena de texto con los parametros de entrada.

        In_log:= TO_CHAR(antiguedad);  
        

       --Abrimos el cursor
       
        OPEN CURSOR_R FOR
		SELECT id_contador, direccion, localidad, pais, any_fabricacion FROM tb_Contadores
		WHERE (SELECT TO_NUMBER(TO_CHAR(SYSDATE,'YYYY')) FROM DUAL)-(any_fabricacion)>antiguedad;
        
        --Recorremos el cursor para comprobar resultados 
        LOOP FETCH CURSOR_R INTO id_cont, dir, loc, ps, af;
        EXIT WHEN CURSOR_R%NOTFOUND;  
		dbms_output.put_line(id_cont ||'   '||dir ||'   '||loc ||'   '||ps ||'   '||af);
        END LOOP;
	        
        RSP:='OK';
        INSERT INTO tb_Logs VALUES (seq_id_logs.NextVal,fecha_proceso,nombre_proceso,In_log,'cursor con los datos solicitados',RSP); 
        COMMIT;
 
     EXCEPTION

        
        WHEN OTHERS THEN 
        RSP:='ERROR: ' || SQLCODE || ' ' || SQLERRM;  
        INSERT INTO tb_Logs VALUES (seq_id_logs.NextVal,fecha_proceso,nombre_proceso,In_log,NULL,RSP);
    END;

