/* Este disparador nos permitir actualizar la produccin de la centrales en funcin del
 * consumo obtenido en las lecturas de los contadores.
 * Adems y partir de dichas lecturas nos permitira actualizar las diferentes tablas que 
 * componen el mdulo estadstico.
 */
CREATE OR REPLACE
TRIGGER TR_ACTUALIZA_HISTORICO BEFORE INSERT OR UPDATE OF CONSUMO_MES ON TB_LECTURAS 
FOR EACH ROW 
DECLARE
  RSP CLOB;
  BEGIN
      IF INSERTING THEN
          pr_alta_historico(:new.contador,:new.fecha,:new.consumo_mes, RSP);
      END IF;
      
      IF UPDATING THEN
          IF(:new.consumo_mes <> :old.consumo_mes)THEN
            pr_modifica_historico(:new.contador,:new.fecha,:new.consumo_mes, :old.consumo_mes, RSP);
          END IF;
      END IF;
  END;
  /