--declaramos la variable de retorno que pasaremos como parmetro.
DECLARE 
  RSP CLOB;
  CURSOR_R SYS_REFCURSOR;
BEGIN

/*
   PROCEDIMIENTOS DE ALTAS
 */

--Repetimos un cliente ya introducido en la BD
pr_alta_cliente ('44444444E','Pedro Carmona Moliner','Naranjos 65','Madrid','Spain',RSP);

--Repetimos la identificacin de un contador
pr_alta_contador(1001,'Torrent 12','Valencia','Spain','CLK110',2000,'CAMILLE',0.0,RSP);

--Pasamos valores de emisin nulos para la central de produccin.
pr_alta_central_p('H-0012','TERMICA','CARRETERA DEL MEDIO S/N','HUESCA','SPAIN',NULL,NULL,NULL,NULL,NULL,'20/07/2008',RSP);

--La central de produccin no existe en la BD
pr_alta_linea(2801,75000,'M-0029',RSP);

--Pasamos valores nulos en la direccin que forma parte la clave primaria de la central
pr_alta_central_d(NULL,'SORIA','SPAIN',8000,RSP);

--La Central de distribucin no existe por direccin erronea
pr_alta_alimentacion('POLIGONO BEOS, S/N','BARCELONA','SPAIN',8001,RSP);

--El contador no existe en la BD
pr_alta_distribucion(1013,'CENTRALISMO, S/N','MADRID','SPAIN',RSP);

--El contrato ya ha sido dado de alta.
pr_alta_contrato('AA001','12/06/2009',4.6,'44444444E',1005,RSP);

--Pasamos un valor nulo para la modalidad de lectura.
pr_alta_lectura(1012,'31/01/2011',NULL,4400.00,RSP); 


/*
    PROCEDIMIENTOS DE MODIFICACION
 */

--EL cliente no existe
pr_modifica_cliente('99999999B','Manuel Lpez Lorenzo','Somiedo 23','Oviedo','Spain',RSP);

--El contador no existe en la BD
pr_modifica_contador(101,'Calabria 1','Barcelona','Spain',RSP); 

--Valores nulos para el tipo de central
pr_modifica_central_p('B-0008',NULL,NULL,NULL,NULL,NULL,'25/08/2011',RSP);--modificamos la fecha de la ltima inspeccin

--La lnea no existe
pr_modifica_linea(8010,60000,RSP);--modificamos la capacidad de la lnea

--Valor nulo en la variable a modificar
pr_modifica_central_d('POLIGONO BESOS, S/N','BARCELONA','SPAIN',NULL,RSP);

--La fecha de baja es menor que la fecha de alta del contrato
pr_modifica_contrato('AA000','14/04/2000',NULL,RSP);

--Valores nulos
pr_modifica_lectura(1004,'30/04/2012',NULL,NULL,RSP);

/*
    PROCEDIMIENTOS DE BAJA
 */

--El contrato no tiene fecha de baja
pr_baja_contrato('CC000',RSP);

--La asociacin no existe en la tabla TB_ALIMENTACION
pr_baja_alimentacion('MONTSERRAT 1','BARCELONA','FRANCE',8025,RSP);

--La asociacin entre la centrales de distribucion y el contador no existe en la BD
pr_baja_distribucion(2000,'PERALES 5','MADRID','SPAIN',RSP);

/*
    PROCEDIMIENTOS DE CONSULTA
 */

--La ciudad no existe
pr_consulta_a('Segovia','15/07/2010',CURSOR_R, RSP);

--No existe lectura en la fecha dada
pr_consulta_e('B-0008','31/12/2007','31/01/2008',CURSOR_R, RSP);

--No existe lectura en la fecha dada
pr_consulta_f('01/01/2008','05/05/2008',CURSOR_R, RSP);

END;
